Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 3579)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 3582)
@@ -9341,21 +9374,44 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,2),                 &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                DO  k = nzb_do, nzt_do
+                   local_pf(i,j,k) = MERGE( Ntot_av(k,j,i), REAL( fill_value,  &
+                                            KIND = wp ), BTEST(                &
+                                            wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
              ENDDO
           ENDDO
        ENDIF
+
+       IF ( mode == 'xy' )  grid = 'zu'
+    
+    
+    ELSEIF ( TRIM( variable(1:5) ) == 'm_bin' )  THEN
        
-    ELSEIF ( TRIM( variable(1:6) ) == 'N_bin3' )  THEN
+       vari = TRIM( variable( 6:LEN( TRIM( variable ) ) - 3 ) )
+    
+       IF ( TRIM( vari ) == '1' ) b = 1
+       IF ( TRIM( vari ) == '2' ) b = 2
+       IF ( TRIM( vari ) == '3' ) b = 3
+       IF ( TRIM( vari ) == '4' ) b = 4
+       IF ( TRIM( vari ) == '5' ) b = 5
+       IF ( TRIM( vari ) == '6' ) b = 6
+       IF ( TRIM( vari ) == '7' ) b = 7
+       IF ( TRIM( vari ) == '8' ) b = 8
+       IF ( TRIM( vari ) == '9' ) b = 9
+       IF ( TRIM( vari ) == '10' ) b = 10
+       IF ( TRIM( vari ) == '11' ) b = 11
+       IF ( TRIM( vari ) == '12' ) b = 12
+       
        IF ( av == 0 )  THEN
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(3)%conc(k,j,i),     &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                DO  k = nzb_do, nzt_do   
+                   temp_bin = 0.0_wp
+                   DO  c = b, ncc_tot * nbins, nbins
+                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
+                   ENDDO
+                   local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value,        &
+                                            KIND = wp ), BTEST(                &
+                                            wall_flags_0(k,j,i), 0 ) )
                 ENDDO
              ENDDO
@@ -9364,547 +9420,14 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,3),                 &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                DO  k = nzb_do, nzt_do                      
+                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,b), REAL( fill_value,&
+                                            KIND = wp ), BTEST(                &
+                                            wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
              ENDDO
           ENDDO
        ENDIF
-    
-    ELSEIF ( TRIM( variable(1:6) ) == 'N_bin4' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(4)%conc(k,j,i),     &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,4),                 &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
        
-    ELSEIF ( TRIM( variable(1:6) ) == 'N_bin5' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(5)%conc(k,j,i),     &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,5),                 &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:6) ) == 'N_bin6' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(6)%conc(k,j,i),     &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,6),                 &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:6) ) == 'N_bin7' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(7)%conc(k,j,i),     &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,7),                 &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:6) ) == 'N_bin8' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(8)%conc(k,j,i),     &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,8),                 &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:6) ) == 'N_bin9' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(9)%conc(k,j,i),     &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,9),                 &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-    
-    ELSEIF ( TRIM( variable(1:7) ) == 'N_bin10' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(10)%conc(k,j,i),    &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,10),                &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:7) ) == 'N_bin11' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(11)%conc(k,j,i),    &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,11),                &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:7) ) == 'N_bin12' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(12)%conc(k,j,i),    &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,12),                &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-    
-    ELSEIF ( TRIM( variable(1:4) ) == 'Ntot' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1
-                   temp_bin = 0.0_wp
-                   DO  b = 1, nbins
-                      temp_bin = temp_bin + aerosol_number(b)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1
-                   local_pf(i,j,k) = MERGE( Ntot_av(k,j,i), REAL( -999.0_wp,   &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-
        IF ( mode == 'xy' )  grid = 'zu'
-    
-    
-    ELSEIF ( TRIM( variable(1:6) ) == 'm_bin1' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 1, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,1), REAL( -999.0_wp,&
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-    
-    ELSEIF ( TRIM( variable(1:6) ) == 'm_bin2' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 2, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,2), REAL( -999.0_wp,&
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:6) ) == 'm_bin3' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 3, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,3), REAL( -999.0_wp,&
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:6) ) == 'm_bin4' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 4, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,4), REAL( -999.0_wp,&
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:6) ) == 'm_bin5' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 5, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,5), REAL( -999.0_wp,&
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:6) ) == 'm_bin6' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 6, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,6), REAL( -999.0_wp,&
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:6) ) == 'm_bin7' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 7, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,7), REAL( -999.0_wp,&
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:6) ) == 'm_bin8' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 8, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,8), REAL( -999.0_wp,&
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:6) ) == 'm_bin9' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 9, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,9), REAL( -999.0_wp,&
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:7) ) == 'm_bin10' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 10, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,10), REAL(          &
-                       -999.0_wp, KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:7) ) == 'm_bin11' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 11, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,11), REAL(          &
-                       -999.0_wp, KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
-    ELSEIF ( TRIM( variable(1:7) ) == 'm_bin12' )  THEN
-       IF ( av == 0 )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1   
-                   temp_bin = 0.0_wp
-                   DO  c = 12, ncc_tot*nbins, nbins
-                      temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                   ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                ENDDO
-             ENDDO
-          ENDDO
-       ELSE
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( mbins_av(k,j,i,12), REAL(          &
-                       -999.0_wp, KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
     
     ELSEIF ( TRIM( variable(1:5) ) == 'PM2.5' )  THEN
@@ -9912,5 +9435,5 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1
+                DO  k = nzb_do, nzt_do
                    temp_bin = 0.0_wp
                    DO  b = 1, nbins
@@ -9921,6 +9444,7 @@
                       ENDIF
                    ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,         &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                   local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value,        &
+                                            KIND = wp ), BTEST(                &
+                                            wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
              ENDDO
@@ -9929,7 +9453,8 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1
-                   local_pf(i,j,k) = MERGE( PM25_av(k,j,i), REAL( -999.0_wp,   &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                DO  k = nzb_do, nzt_do
+                   local_pf(i,j,k) = MERGE( PM25_av(k,j,i), REAL( fill_value,  &
+                                            KIND = wp ), BTEST(                &
+                                            wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
              ENDDO
@@ -9944,5 +9469,5 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1
+                DO  k = nzb_do, nzt_do
                    temp_bin = 0.0_wp
                    DO  b = 1, nbins
@@ -9953,6 +9478,7 @@
                       ENDIF
                    ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin,  REAL( -999.0_wp,        &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                   local_pf(i,j,k) = MERGE( temp_bin,  REAL( fill_value,       &
+                                            KIND = wp ), BTEST(                &
+                                            wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
              ENDDO
@@ -9961,7 +9487,8 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1
-                   local_pf(i,j,k) = MERGE( PM10_av(k,j,i), REAL( -999.0_wp,   &
-                                 KIND = wp ),  BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                DO  k = nzb_do, nzt_do
+                   local_pf(i,j,k) = MERGE( PM10_av(k,j,i), REAL( fill_value,  &
+                                            KIND = wp ), BTEST(                &
+                                            wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
              ENDDO
@@ -9978,11 +9505,12 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       temp_bin = 0.0_wp
                       DO  c = ( icc-1 )*nbins+1, icc*nbins, 1
                          temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
                       ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin, REAL( -999.0_wp,      &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value,     &
+                                               KIND = wp ), BTEST(             &
+                                               wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
                 ENDDO
@@ -9998,7 +9526,7 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i),          &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -10007,5 +9535,5 @@
           ENDIF
        ELSE
-          local_pf = 0.0_wp 
+          local_pf = fill_value
        ENDIF
 
@@ -10027,9 +9555,11 @@
 !> Subroutine defining 3D output variables
 !------------------------------------------------------------------------------!
- SUBROUTINE salsa_data_output_3d( av, variable, found, local_pf )
+ SUBROUTINE salsa_data_output_3d( av, variable, found, local_pf, nzb_do,       &
+                                  nzt_do )
 
     USE indices
 
     USE kinds
+    
 
     IMPLICIT NONE
@@ -10037,24 +9567,28 @@
     CHARACTER (LEN=*), INTENT(in) ::  variable   !< 
     
-    INTEGER(iwp) ::  av   !< 
-    INTEGER(iwp) ::  c    !<
-    INTEGER(iwp) ::  i    !<
-    INTEGER(iwp) ::  icc  !< index of a chemical compound
-    INTEGER(iwp) ::  j    !< 
-    INTEGER(iwp) ::  k    !< 
-    INTEGER(iwp) ::  n    !<
-
-    LOGICAL ::  found   !< 
-    REAL(wp) ::  df       !< For calculating LDSA: fraction of particles 
-                          !< depositing in the alveolar (or tracheobronchial)
-                          !< region of the lung. Depends on the particle size 
-    REAL(wp) ::  mean_d   !< Particle diameter in micrometres
-    REAL(wp) ::  nc       !< Particle number concentration in units 1/cm**3
-
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf  !< local
-                                  !< array to which output data is resorted to
-    REAL(wp) ::  temp_bin  !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< points to 
-                                                     !< selected output variable
+    INTEGER(iwp) ::  av      !<
+    INTEGER(iwp) ::  b       !< running index: size bins    
+    INTEGER(iwp) ::  c       !< running index: mass bins
+    INTEGER(iwp) ::  i       !<
+    INTEGER(iwp) ::  icc     !< index of a chemical compound
+    INTEGER(iwp) ::  j       !< 
+    INTEGER(iwp) ::  k       !< 
+    INTEGER(iwp) ::  nzb_do  !< 
+    INTEGER(iwp) ::  nzt_do  !<   
+
+    LOGICAL ::  found      !< 
+    
+    REAL(wp) ::  df        !< For calculating LDSA: fraction of particles 
+                           !< depositing in the alveolar (or tracheobronchial)
+                           !< region of the lung. Depends on the particle size 
+    REAL(wp) ::  fill_value = -9999.0_wp   !< value for the _FillValue attribute
+    REAL(wp) ::  mean_d    !< Particle diameter in micrometres
+    REAL(wp) ::  nc        !< Particle number concentration in units 1/cm**3
+    REAL(wp) ::  temp_bin  !< temporary array for calculating output variables    
+
+    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< local 
+    
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< pointer
+                                                     
        
     found     = .TRUE.
